Package org.apache.sysds.hops.codegen.cplan

# Class CNode

java.lang.Object
org.apache.sysds.hops.codegen.cplan.CNode

Direct Known Subclasses:
  `CNodeBinary`, `CNodeData`, `CNodeNary`, `CNodeTernary`, `CNodeTpl`, `CNodeUnary`

public abstract class CNode extends Object

## Constructor Summary

Constructors
Constructor
Description
`CNode()`

## Method Summary

Modifier and Type
Method
Description
`abstract String`
`codegen(boolean sparse, SpoofCompiler.GeneratorAPI api)`
`String`
`createVarname()`
`String`
`createVarname(boolean sparse)`
`boolean`
`equals(Object that)`
`String`
`getClassname()`
`Types.DataType`
`getDataType()`
`long`
`getID()`
`ArrayList<CNode>`
`getInput()`
`long`
`getNumCols()`
`long`
`getNumRows()`
`CNode`
`getOutput()`
`String`
`getVarname()`
`String`
`getVarname(SpoofCompiler.GeneratorAPI api)`
`String`
`getVectorLength(SpoofCompiler.GeneratorAPI api)`
`int`
`hashCode()`
`boolean`
`isGenerated()`
`boolean`
`isLiteral()`
`abstract boolean`
`isSupported(SpoofCompiler.GeneratorAPI api)`
`boolean`
`isVisited()`
`void`
`resetGenerated()`
`void`
`resetHash()`
`void`
`resetVisitStatus()`
`void`
`setDataType(Types.DataType dt)`
`void`
`setLiteral(boolean literal)`
`void`
`setNumCols(long cols)`
`void`
`setNumRows(long rows)`
`void`
`setOutput(CNode output)`
`abstract void`
`setOutputDims()`
`void`
`setVarName(String name)`
`void`
`setVisited()`
`void`
`setVisited(boolean flag)`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### CNode

public CNode()

## Method Details

### getID

public long getID()

### getInput

public ArrayList<CNode> getInput()

### isGenerated

public boolean isGenerated()

### resetGenerated

public void resetGenerated()

### createVarname

public String createVarname()

### createVarname

public String createVarname(boolean sparse)

### getVarname

public String getVarname()

### getVarname

public String getVarname(SpoofCompiler.GeneratorAPI api)

### getVectorLength

public String getVectorLength(SpoofCompiler.GeneratorAPI api)

### getClassname

public String getClassname()

### resetHash

public void resetHash()

### setNumRows

public void setNumRows(long rows)

### getNumRows

public long getNumRows()

### setNumCols

public void setNumCols(long cols)

### getNumCols

public long getNumCols()

### getDataType

public Types.DataType getDataType()

### setDataType

public void setDataType(Types.DataType dt)

### isLiteral

public boolean isLiteral()

### setLiteral

public void setLiteral(boolean literal)

### getOutput

public CNode getOutput()

### setOutput

public void setOutput(CNode output)

### isVisited

public boolean isVisited()

### setVisited

public void setVisited()

### setVisited

public void setVisited(boolean flag)

### resetVisitStatus

public void resetVisitStatus()

### codegen

public abstract String codegen(boolean sparse, SpoofCompiler.GeneratorAPI api)

### setOutputDims

public abstract void setOutputDims()

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `Object`

### equals

public boolean equals(Object that)

Overrides:
  `equals` in class `Object`

### isSupported

public abstract boolean isSupported(SpoofCompiler.GeneratorAPI api)

### setVarName

public void setVarName(String name)